# Jasmine Core 2.3.0 Release Notes

## Changes

* Style disabled specs in the results list
* Use `onclick` directly to better support older webkit
* Don't use deprecated `onComplete` syntax for jasmine-npm
* Allow the clock to be installed for the duration of a single closure
* Add safari 7 & 8 to browser matrix
* Remove unused standaloneBuilder var from Gruntfile
* Add test script to package.json
* Update bower.json keywords to match package.json keywords
* Add keywords to package.json
* refuse to execute an order if it would cause a suite with a beforeAll or afterAll to be re-entered after leaving once

## Pull Requests & Issues

* Specify a main entry point for bower so it can be loaded easier
    - Merges [#827](https://github.com/jasmine/jasmine/issues/827) from @davetron5000

* Use `instanceof` when checking Error types in toThrowError
    - Fixes [#819](https://github.com/jasmine/jasmine/issues/819)

* Remove periods from bullet points for consistency with rest of document
    - Merge [#818](https://github.com/jasmine/jasmine/issues/818) from @lpww

* Subjective readability improvements to CONTRIBUTING.md
    - Merge [#815](https://github.com/jasmine/jasmine/issues/815) from @jhamon

* Don't install the clock if the current timing functions aren't the originals
    - Fixes [#782](https://github.com/jasmine/jasmine/issues/782)

* Properly pass `j$` to `Any` so it can use other jasmine stuff
    - Fixes [#806](https://github.com/jasmine/jasmine/issues/806)

* Correctly handle functions that are scheduled after the clock is uninstalled and reinstalled from within Clock#tick.
    - Merges [#804](https://github.com/jasmine/jasmine/issues/804) from @sgravrock
    - Fixes [#790](https://github.com/jasmine/jasmine/issues/790).

* Allow user to stop a specs execution when an expectation fails
    - Fixes [#577](https://github.com/jasmine/jasmine/issues/577)

* Remove unnecessary conditional
    - Merges [#788](https://github.com/jasmine/jasmine/issues/788) from @toddbranch

* Show the name of the constructor function when printing an `any` instead of a `toString` of the entire constructor
    - Fixes [#796](https://github.com/jasmine/jasmine/issues/796)

* Don't use hardcoded temporary directory paths
    - Merges [#789](https://github.com/jasmine/jasmine/issues/789) from sgravrock

* Execute beforeAll/afterAll once per suite instead of once per child when running focused specs/suites
    - Fixes [#773](https://github.com/jasmine/jasmine/issues/773)

* Report children of an xdescribe similarly to how they would be reported if they were themselves x'd out
    - Fixes [#774](https://github.com/jasmine/jasmine/issues/774)
    - Fixes [#776](https://github.com/jasmine/jasmine/issues/776)

* Fixes issue where mock clock was being used by QueueRunner
    - Fixes [#783](https://github.com/jasmine/jasmine/issues/783)
    - Fixes [#792](https://github.com/jasmine/jasmine/issues/792)

* add missing semicolon
    - Merges [#775](https://github.com/jasmine/jasmine/issues/775) from @joscha

* ObjectContaining matches prototype properties
    - Fixes [#769](https://github.com/jasmine/jasmine/issues/769)

* Updates pretty printer to include array properties
    - Fixes [#766](https://github.com/jasmine/jasmine/issues/766)

* Update year copyright
    - Merges [#768](https://github.com/jasmine/jasmine/issues/768) from @danilovaz

* Allow arrays from different frames or contexts to be equal
    - Merges [#767](https://github.com/jasmine/jasmine/issues/767) from @juliemr
    - Fixes [#765](https://github.com/jasmine/jasmine/issues/765)

------

_Release Notes generated with _[Anchorman](http://github.com/infews/anchorman)_
