# Jasmine Core 2.4.0 Release Notes

## Summary

This release contains a number of fixes and pull requests.
The most notable is probably that Jasmine now supports randomization of spec order

## Changes

* Run jasmine's specs in random order
* Add support for returning run details for reporting randomness
* Use className instead of class when creating DOM elements


## Pull Requests & Issues

* Syntax highlighting in README.md
    - Merges [#973](https://github.com/jasmine/jasmine/issues/973) from @brunoqc

* Added a throw error block in describe incase a function with arguments is passed in describe
    - Fixes [#896](https://github.com/jasmine/jasmine/issues/896)
    - Merges [#955](https://github.com/jasmine/jasmine/issues/955) from @himajasuman

* Remove unused `queueableFn` arg from `onException`
    - Fixes [#958](https://github.com/jasmine/jasmine/issues/958)

* Remove unused parameter from toThrowError
    - Merges [#957](https://github.com/jasmine/jasmine/issues/957) from @FuzzySockets

* Abort spying when the target cannot be spied upon
    - Fixes [#948](https://github.com/jasmine/jasmine/issues/948)
    - Merges [#949](https://github.com/jasmine/jasmine/issues/949) from @StephanBijzitter

* Removed GOALS_2.0.md, doesn't seem to be needed anymore
    - Merges [#954](https://github.com/jasmine/jasmine/issues/954) from @matthewhuff89

* Change #xit so that it will output a more BDD-style pending message
    - Merges [#942](https://github.com/jasmine/jasmine/issues/942) from @lalunamel
    - Fixes [#930](https://github.com/jasmine/jasmine/issues/930)
    - Fixes [#912](https://github.com/jasmine/jasmine/issues/912)

* Allow tests to run in random order
    - Merges [#927](https://github.com/jasmine/jasmine/issues/927) from @marcioj

* Use toString for objects if it has been overriden
    - Merges [#929](https://github.com/jasmine/jasmine/issues/929) from @myitcv
    - Fixes [#928](https://github.com/jasmine/jasmine/issues/928)

* Fix circles/x from getting cut off on Mac/chrome
    - Merges [#932](https://github.com/jasmine/jasmine/issues/932) from @James-Dunn

* Postpone find() until it is needed
    - Merges [#924](https://github.com/jasmine/jasmine/issues/924) from @danielalexiuc
    - Fixes [#917](https://github.com/jasmine/jasmine/issues/917)

* check for global before assigning
* Reverse suite afterEach behavior to match semantics?
    - Merges [#908](https://github.com/jasmine/jasmine/issues/908) from @mcamac

* Use badges from shields.io
    - Merges [#902](https://github.com/jasmine/jasmine/issues/902) from @SimenB

* xdescribe marks pending, plus associated tests.
    - Merges [#869](https://github.com/jasmine/jasmine/issues/869) from @ljwall
    - Fixes [#855](https://github.com/jasmine/jasmine/issues/855)

* Update glob to latest
    - Merge [#892](https://github.com/jasmine/jasmine/issues/892) from @obastemur
    - Fixes [#891](https://github.com/jasmine/jasmine/issues/891)

* Remove moot `version` property from bower.json
    - Merges [#874](https://github.com/jasmine/jasmine/issues/874) from @kkirsche

* add toHaveBeenCalledTimes matcher
    - Merges [#871](https://github.com/jasmine/jasmine/issues/871) from @logankd
    - Fixes [#853](https://github.com/jasmine/jasmine/issues/853)

* Update CONTRIBUTING.md
    - Merges [#856](https://github.com/jasmine/jasmine/issues/856) from @lpww

* Make the HtmlReport CSS classes "unique enough"
    - Merges [#851](https://github.com/jasmine/jasmine/issues/851) from @prather-mcs
    - Fixes [#844](https://github.com/jasmine/jasmine/issues/844)

* Raise an error when jasmine.any() isn't passed a constructor
    - Merges [#854](https://github.com/jasmine/jasmine/issues/854) from @danfinnie
    - Fixes [#852](https://github.com/jasmine/jasmine/issues/852)

------

_Release Notes generated with _[Anchorman](http://github.com/infews/anchorman)_
