# Jasmine 2.5.0 Release Notes 

## Summary

This release contains a number of fixes and pull requests.

## Changes

* Rename `j$` to `jasmineUnderTest` for specs
    - Please update any pull requests to simplify merging, thanks.

## Pull Requests & Issues

* Prettyprint objects whose constructors have custom toString method
  - Fixes [#1019](https://github.com/jasmine/jasmine/issues/1019)
  - Merges [#1099](https://github.com/jasmine/jasmine/issues/1099) from @mbildner

* Add gulp-jasmine-browser link to readme
  - Fixes [#1089](https://github.com/jasmine/jasmine/issues/1089)

* Exclude lib directory from codeclimate
  - Fixes [#1171](https://github.com/jasmine/jasmine/issues/1171)

* Add instructions for testing in IE
  - Merges [#1170](https://github.com/jasmine/jasmine/issues/1170) from @benchristel

* Update devDependencies and fix issues from this
  - Merges [#1162](https://github.com/jasmine/jasmine/issues/1162) from @amavisca

* Remove runnableLookupTable which is no longer used
  - Merges [#1129](https://github.com/jasmine/jasmine/issues/1129) from @gregeninfrank

* Make `toEqual` pass for arrays with equivalent properties
  - Merges [#1155](https://github.com/jasmine/jasmine/issues/1155) from @benchristel

* Update ruby version on travis to let rack install
  - Merges [#1152](https://github.com/jasmine/jasmine/issues/1152) from @amavisca

* Fix jasmine setup in Electron environment
  - Merges [#1079](https://github.com/jasmine/jasmine/issues/1079) from @skupr
  - Fixes [#964](https://github.com/jasmine/jasmine/issues/964)

* Improve errors with the domain and how to use the API
  - Merges [#1026](https://github.com/jasmine/jasmine/issues/1026) from @dhoko
  - Fixes [#1025](https://github.com/jasmine/jasmine/issues/1025)

* The done function now returns null
  - Merges [#1062](https://github.com/jasmine/jasmine/issues/1062) from @marneborn
  - Fixes [#992](https://github.com/jasmine/jasmine/issues/992)

* Add .editorconfig file
  - Merges [#1058](https://github.com/jasmine/jasmine/issues/1058) from @kapke
  - Fixes [#1057](https://github.com/jasmine/jasmine/issues/1057)

* Improve error message when passing a non-function to callFake
  - Merges [#1059](https://github.com/jasmine/jasmine/issues/1059) from @kapke
  - Fixes [#1016](https://github.com/jasmine/jasmine/issues/1016)

* Allow expectations in a global beforeAll or afterAll
  - Fixes [#811](https://github.com/jasmine/jasmine/issues/811)

* Correctly tear down spies on inherited methods
  - Merges [#1036](https://github.com/jasmine/jasmine/issues/1036) from @benchristel
  - Fixes [#737](https://github.com/jasmine/jasmine/issues/737)

* Array equality treats undefined elements as equal however they got in there
  - Fixes [#786](https://github.com/jasmine/jasmine/issues/786)

* Add support for a fallback reporter
  - Merges [#1009](https://github.com/jasmine/jasmine/issues/1009) from @mauricioborges

* Grunt task for compass should prefix command with 'bundle exec'
  - Merges [#1047](https://github.com/jasmine/jasmine/issues/1047) from @d-reinhold

* Fix `toEqual` for Microsoft Edge
  - Merges [#1041](https://github.com/jasmine/jasmine/issues/1041) from @everedifice

* Update describe error message to no longer assume errant args are `done`
  - Fixes [#896](https://github.com/jasmine/jasmine/issues/896)

* Add toBeGreatThanOrEqual and toBeLessThanOrEqual matchers
  - Merges [#1049](https://github.com/jasmine/jasmine/issues/1049) from @rullopat
  - Fixes [#1013](https://github.com/jasmine/jasmine/issues/1013)

* Support call count of 0 with toHaveBeenCalledTimes matcher
  - Merges [#1048](https://github.com/jasmine/jasmine/issues/1048) from @logankd
  - Fixes [#994](https://github.com/jasmine/jasmine/issues/994)

* Correctly clean up spies after a spy is replaced and re-spied upon
  - Merges [#1011](https://github.com/jasmine/jasmine/issues/1011) from @bodawei
  - Fixes [#1010](https://github.com/jasmine/jasmine/issues/1010)

* remove extra topSuite `queueRunner` construction parameter
  - Merges [#1006](https://github.com/jasmine/jasmine/issues/1006) from @jurko-gospodnetic

* add option to shallow clone args in call tracker
  - Merges [#1000](https://github.com/jasmine/jasmine/issues/1000) from @a-r-d
  - Fixes [#872](https://github.com/jasmine/jasmine/issues/872)

* Update license year range to 2016
    - Merges [#1021](https://github.com/jasmine/jasmine/issues/1021) from pra85

* Persist randomize param in 'run all' links
    - Merges [#990](https://github.com/jasmine/jasmine/issues/990) from @basawyer

* make DelayedFunctionScheduler update the mockDate
    - Fixes [#915](https://github.com/jasmine/jasmine/issues/915)
    - Merges [#980](https://github.com/jasmine/jasmine/issues/980) from @andrewiggings

* Allow `spyOn` to allow a respy for functions that have already been spied upon
  - Merges [#953](https://github.com/jasmine/jasmine/issues/953) from @guy-mograbi-at-gigaspaces
  - Fixes [#931](https://github.com/jasmine/jasmine/issues/931)

------

_Release Notes generated with _[Anchorman](http://github.com/infews/anchorman)_
