# Jasmine 2.7.0 Release Notes

## Summary

This release contains a number of fixes and pull requests.

## Pull Requests & Issues


* Add class UserContext
  - Merges [#1400](https://github.com/jasmine/jasmine/issues/1400) from @darthjee

* Send unfocused tests through the same queue as focused tests
  - Merges [#1399](https://github.com/jasmine/jasmine/issues/1399) from @jberney

* PrettyPrinter allows an object to have a `toString` that isn't a function
  - Fixes [#1389](https://github.com/jasmine/jasmine/issues/1389)

* Fix rounding in toBeCloseTo
  - Fixes [#1382](https://github.com/jasmine/jasmine/issues/1382)

* When stop on failure is enabled, skip subsequent it() and beforeEach(). Note: afterEach() functions are still run, because skipping them is highly likely to pollute specs that run after the failure.
  - Fixes [#577](https://github.com/jasmine/jasmine/issues/577)
  - Fixes [#807](https://github.com/jasmine/jasmine/issues/807)

* Only clear out the `spec` param for Run all link
  - Fixes [#1369](https://github.com/jasmine/jasmine/issues/1369)

* Pretty printer will now use MAX_PRETTY_PRINT_ARRAY_LENGTH for objects
  - Fixes [#1291](https://github.com/jasmine/jasmine/issues/1291)
  - Fixes [#1360](https://github.com/jasmine/jasmine/issues/1360)

* updated package glob from 7.0.5 to 7.1.2
  - Merges [#1368](https://github.com/jasmine/jasmine/issues/1368) from @EsrefDurna

* Fix bower.json url to be https instead of http
  - Merges [#1365](https://github.com/jasmine/jasmine/issues/1365) from @kant

* Fail when one of the arguments passed into toBeCloseTo matcher is null
  - Merges [#1362](https://github.com/jasmine/jasmine/issues/1362) from @beatrichartz

* Fixed HTML snippet in README
  - Closes [#1366](https://github.com/jasmine/jasmine/issues/1366).

* Report the random seed at the beginning and end of execution. This allows reporters to provide the seed to the user even in cases where Jasmine crashes before completing.
  - Merges [#1348](https://github.com/jasmine/jasmine/issues/1348) from @sgravrock

* Add ES6 map support to Jasmine
  - Merges [#1340](https://github.com/jasmine/jasmine/issues/1340) from @rmehlinger
  - Fixes [#1257](https://github.com/jasmine/jasmine/issues/1257)

* Added support for async before/it/after functions that return promises and added support for ES2017 async functions
  - Merges [#1356](https://github.com/jasmine/jasmine/issues/1356) from @sgravrock
  - Fixes [#1336](https://github.com/jasmine/jasmine/issues/1336)
  - Fixes [#1270](https://github.com/jasmine/jasmine/issues/1270)
  - Fixes [#1350](https://github.com/jasmine/jasmine/issues/1350)
  - Fixes [#1320](https://github.com/jasmine/jasmine/issues/1320)

------

_Release Notes generated with _[Anchorman](http://github.com/infews/anchorman)_
