# Jasmine 2.9 Release Notes

## Summary

This release contains a number of fixes and pull requests.

## Changes

* Fixed DelayedFunctionScheduler IE 8 compatibility issue
* Fixed SPEC HAS NO EXPECTATIONS warning in HTML reporter
* Correctly remove spies of window.onerror on IE
* Truncate pretty printer output that is more than j$.MAX_PRETTY_PRINT_CHARS long
* Reduced pretty printer limits to much smaller values
* Update contributing for new naming of `jasmineUnderTest`
* Allowed async functions to be passed into spy#callFake

## Pull Requests & Issues

* Added complete support for Set also for IE11.
  - Merges [#1478](https://github.com/jasmine/jasmine/issues/1478) from @Volox
  - Fixes [#1355](https://github.com/jasmine/jasmine/issues/1355)


* Added complete support for Map also for IE11.
  - Merges [#1477](https://github.com/jasmine/jasmine/issues/1477) from @Volox
  - Fixes [#1472](https://github.com/jasmine/jasmine/issues/1472)


* Use timeout objects when in node
  - Merges [#1470](https://github.com/jasmine/jasmine/issues/1470) from @chris--young
  - Fixes [#1469](https://github.com/jasmine/jasmine/issues/1469)


* Fixed `pending()` for `async`/promise-returning specs
  - Fixes [#1449](https://github.com/jasmine/jasmine/issues/1449)
  - Fixes [#1450](https://github.com/jasmine/jasmine/issues/1450)


* Added test steps for other major node versions
    - Merges [#1448](https://github.com/jasmine/jasmine/issues/1448) from @mrlannigan


* Fix equality computation for ES6 Sets.
  - Merges [#1445](https://github.com/jasmine/jasmine/issues/1445) from @b-3-n
  - Fixes [#1444](https://github.com/jasmine/jasmine/issues/1444)


* Add instruction to sync local master with upstream
  - Merges [#1440](https://github.com/jasmine/jasmine/issues/1440) from aaronang


* Add some unit tests that exercise jasmine.anything() and Map matching.
  - Merges [#1437](https://github.com/jasmine/jasmine/issues/1437) from @voithos


* Add special handling of asymmetric matcher objects as keys in Maps.
  - Merges [#1436](https://github.com/jasmine/jasmine/issues/1436) from @voithos
  - Fixes [#1432](https://github.com/jasmine/jasmine/issues/1432)


* Add support for jasmine.any(Symbol).
  - Merge [#1435](https://github.com/jasmine/jasmine/issues/1435) from @voithos
  - Fixes [#1431](https://github.com/jasmine/jasmine/issues/1431)


* Throw an error for invalid nesting of a suite functions
  - Merges [#1411](https://github.com/jasmine/jasmine/issues/1411) from @ksvitkovsky
  - Fixes [#1295](https://github.com/jasmine/jasmine/issues/1295)


* Deep clone args before passing them to reporters
  - Merges [#1424](https://github.com/jasmine/jasmine/issues/1424) from @aj-dev


* Fix "Before Committing" section of CONTRIBUTING.md.
  - Merges [#1429](https://github.com/jasmine/jasmine/issues/1429) from @voithos


* Fix lint warning in CallTracker.
  - Merges [#1428](https://github.com/jasmine/jasmine/issues/1428) from @voithos


* clearTimeout should now correctly clear a timeout that is also scheduled to run at the same tick.
  - Merges [#1427](https://github.com/jasmine/jasmine/issues/1427) from @leahciMic
  - Fixes [#1426](https://github.com/jasmine/jasmine/issues/1426)


* Add a note about `defineProperty` for `spyOnProperty`
  - Fixes [#1415](https://github.com/jasmine/jasmine/issues/1415)


* Add Promise checking to eq
  - Merges [#1386](https://github.com/jasmine/jasmine/issues/1386) from @sderickson
  - Fixes [#1314](https://github.com/jasmine/jasmine/issues/1314)


------

_Release Notes generated with _[Anchorman](http://github.com/infews/anchorman)_
