# Jasmine Core 3.10 Release Notes

## New features and bug fixes

* Added support for running Jasmine multiple times
  * If the env is configured with `autoCleanClosures: false`, then it can be
    executed repeatedly.
  * Merges #1934 from @nicojs
  * Fixes #1925

* Improved error message when an async expectation occurs after the spec
  finishes
  * Merges #1937 from @AndreWillomitzer
  * Fixes #1854

* Reject timeout values that are too large for setTimeout
    * See #1930

* Don't immediately move to the next queueable fn on async error

  This allows assertion failures and other errors that occur after the async
  error to be routed to the correct spec/suite.

* Added a stringContaining asymmetric equality tester
    * Fixes #1923.

* The jasmine-core Ruby gem now prints a deprecation message when loaded unless
  the SUPPRESS_JASMINE_DEPRECATION environment variable is set.


## Documentation updates

* Added discussion of max timeout value to jsdocs
  * Merges #1931 from @trusktr

* Added missing @since annotations

* Improved jsdocs for asymmetric equality testers

* Added a deprecation notice to the jasmine-core Ruby gem's description

## Supported environments

jasmine-core 3.10.0 has been tested in the following environments.

| Environment       | Supported versions |
|-------------------|--------------------|
| Node              | 10, 12, 14, 16     |
| Safari            | 8-14               |
| Chrome            | 94                 |
| Firefox           | 93, 78, 68         |
| Edge              | 94                 |
| Internet Explorer | 10, 11             |

------

_Release Notes generated with _[Anchorman](http://github.com/infews/anchorman)_
