# Jasmine NPM 3.10 Release Notes

This release updates the jasmine-core dependency to 3.10.0. See the
[jasmine-core release notes](https://github.com/pivotal/jasmine/blob/main/release_notes/3.10.0.md)
for more information.

## New features and bugfixes

* Support for executing the suite multiple times
  * See the jasmine-core release notes for details

* Display the top suite name as "top suite", not "undefined" when reporting 
  suite-level failures

* Fixed reporting of load-time errors from modules imported by specs

* Made the promise returned from `Jasmine#execute` usable
  * Added an exitOnCompletion property to directly control whether Jasmine
    should make the Node process exit. Previously this could only be done by
    calling `Jasmine#onComplete`.
  * The promise returned from `Jasmine#execute` is resolved to the overall
    status.

* Improved interface for programmatically adding files
  * Added Jasmine#addHelperFile
  * Added more clearly named synonyms for Jasmine#addSpecFiles and
    Jasmine#addHelperFiles, and marked the old ones deprecated


## Documentation improvements

* Added jsdoc for `Jasmine#env`


## Internal updates

* Pass stopOnSpecFailure and stopSpecOnExpectationFailure options to core, 
  not the deprecated failFast and oneFailurePerSpec options

* Replaced var with const and let

* Test suite improvements

## Supported environments

The jasmine NPM package has been tested on Node 12, 14, and 16. See the
[jasmine-core release notes](https://github.com/jasmine/jasmine/blob/main/release_notes/3.10.0.md)
for supported browsers.

------

_Release Notes generated with _[Anchorman](http://github.com/infews/anchorman)_
